﻿using JWTVueDemo.Models;
using JWTVueDemo.Models.RequestModel;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Options;
using Microsoft.IdentityModel.Tokens;
using System;
using System.Collections.Generic;
using System.IdentityModel.Tokens.Jwt;
using System.Linq;
using System.Security.Claims;
using System.Text;
using System.Threading.Tasks;

namespace JWTVueDemo.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class AuthController : BaseController
    {
        public AuthController(IOptions<ApplicationSettings> appSettings) : base(appSettings)
        {
        }
        [HttpPost("[action]")]
        public BaseResponse<string> Login(LoginRequestModel loginInfo)
        {
            BaseResponse<string> response = new BaseResponse<string>
            {
                Data = "",
                Msg = "",
                Success = true
            };
            if (loginInfo.Account.Equals("admin") && loginInfo.Password.Equals("123"))
            {
                var key = new SymmetricSecurityKey(Encoding.UTF8.GetBytes(AppSettings.JWTSecret));
                var tokenDescriptor = new SecurityTokenDescriptor
                {
                    Subject = new ClaimsIdentity(new Claim[]
                    {
                        new Claim("UserId","admin"),
                        //new Claim("roles",isAdmin?Roles.Admin:Roles.User)
                    }),
                    Expires = DateTime.UtcNow.AddDays(30),
                    SigningCredentials = new SigningCredentials(key, SecurityAlgorithms.HmacSha256Signature)
                };
                var tokenHandler = new JwtSecurityTokenHandler();
                var securityToken = tokenHandler.CreateToken(tokenDescriptor);
                var token = tokenHandler.WriteToken(securityToken);
                response.Data = token;
                return response;
            }
            else
            {
                response.Success = false;
                response.Msg = "帳號密碼錯誤";
                return response;
            }
        }
    }
}
